//
//  NLWeakReference.h
//  NuDataProvider
//
//  Created by Reid Main on 2012-10-12.
//  Copyright 2012 NuLayer Inc. All rights reserved.
//

#define NLWeakVar(var)            __weak_ ## var

#define NLWeakDeclare(var)        __weak id NLWeakVar(var) = var
#define NLWeakImport(var)         __typeof__(var) var = NLWeakVar(var)
#define NLWeakImportReturn(var)   NLWeakImport(var); do { if(var == nil) return; } while(NO)

#define NLWeakSelfDeclare()       NLWeakDeclare(self)
#define NLWeakSelfImport()        NLWeakImport(self)
#define NLWeakSelfImportReturn()  NLWeakImportReturn(self)

@interface NLWeakReference : NSObject

@property (nonatomic, weak) id referencedObject;

+ (id)weakReferenceWithObject:(id)object;

@end