//
//  NLImageProvider.h
//  NLDataProvider
//
//  Created by Remy Demarest on 15/10/2010.
//  Copyright 2010 Nulayer Inc. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <NuDataProvider/NLDataProvider.h>

@protocol NLImageProviderLoader;

@interface NLImageProvider : NSObject
{
@private
    id<NLDataProvider>   _dataProvider;
    NSCache             *_imageCache;
    NSMutableDictionary *_imageLoaders;
    NSMutableDictionary *_loaderToURL;
}

+ (NLImageProvider *)sharedImageProvider;

@property(nonatomic) id<NLDataProvider> dataProvider;

- (id)initWithCachePath:(NSString *)aPath;
- (void)setCachePath:(NSString *)aPath;
- (void)loadImageAtURL:(NSURL *)aURL forLoader:(id<NLImageProviderLoader>)loader;
- (void)loadImageAtURL:(NSURL *)aURL forLoader:(id<NLImageProviderLoader>)loader finishLoading:(BOOL)alwaysFinish;
- (void)stopLoadingImageForLoader:(id<NLImageProviderLoader>)loader;
- (void)purgeImagesAtURLs:(NSArray *)URLs;
- (void)purgeOldImagesFromCache;

- (NSMutableDictionary *)imagesDictionary;
- (NSString *)plistPath;

@end

@protocol NLImageProviderLoader
- (void)imageProvider:(NLImageProvider *)sender didFinishLoadingImage:(UIImage *)theImage forURL:(NSURL *)aURL;
@end
