//
//  NLJSONDataParser.h
//  NLDataProvider
//
//  Created by Remy Demarest on 15/09/2010.
//  Copyright 2010 Nulayer Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <NuDataProvider/NLDataProvider.h>

@class NLURLParser;

@interface NLJSONDataParser : NSObject <NLDataParser>
{
@private
    NLURLParser *_URLParser;
}

- (id(^)(id JSONData, NSURL *URL, NSDictionary *options, NSError **outError))parserBlockForURL:(NSURL *)aURL ;
- (id(^)(id JSONData, NSURL *URL, NSDictionary *options, NSError **outError))parserBlockForPath:(NSString *)aPath;

// Schemes, no wildcards
- (void)setParseScheme:(NSString *)aScheme withParserBlock:(id (^)(id JSONData, NSURL *URL, NSDictionary *options, NSError **outError))block;
- (void)removeParserForScheme:(NSString *)aScheme;

// All paths are lowercase
// The path accept wildcards as follow: "prefix/*" "*/infix/*" "*/suffix" 
- (void)setParsePath:(NSString *)aPath withParserBlock:(id (^)(id JSONData, NSURL *URL, NSDictionary *options, NSError **outError))block;
- (void)removeParserForPath:(NSString *)aPath;

@property(nonatomic, copy) id (^defaultParser)(id JSONData, NSURL *URL, NSDictionary *options, NSError **outError);

@end
