//
//  NLURLBlockProvider.h
//  NuDataProvider
//
//  Created by Remy Demarest on 24/11/2010.
//  Copyright 2010 NuLayer Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NLURLParser : NSObject
{
@private
    NSMutableDictionary *_schemeToObjects;
    NSMutableDictionary *_pathsToObjects;
    NSMutableDictionary *_pathPrefixesToObjects;
    NSMutableDictionary *_pathSuffixesToObjects;
    NSMutableDictionary *_pathInfixesToObjects;
    
    id                   _defaultObject;
    
    BOOL                 _copyObjects;
}

// Specify whether the objects should be copied when added to the parser. Default is YES
// If YES all objects passed to this class must conform to NSCopying protocol
- (id)initWithCopyObjects:(BOOL)copy;

@property(nonatomic, readonly) BOOL copyObjects;

// URL Parser blocks for NSFetchRequest creation
- (id)objectForURL:(NSURL *)aURL ;
- (id)objectForPath:(NSString *)aPath;

// Schemes, no wildcards
- (void)setObject:(id)obj forURLScheme:(NSString *)aScheme;
- (void)removeObjectForURLScheme:(NSString *)aScheme;

// All paths are lowercase
// The path accept wildcards as follow: "prefix/*" "*/infix/*" "*/suffix" 
- (void)setObject:(id)obj forURLPath:(NSString *)aPath;
- (void)removeObjectForURLPath:(NSString *)aPath;

- (id)defaultObject;
- (void)setDefaultObject:(id)object;

@end
