//
//  NLImageDataParser.m
//  NLDataProvider
//
//  Created by Remy Demarest on 27/09/2010.
//  Copyright 2010 Nulayer Inc. All rights reserved.
//

#import "NLImageDataParser.h"


@implementation NLImageDataParser

- (BOOL)canParseMIMEType:(NSString *)MIMEType;
{
    return [MIMEType hasPrefix:@"image"];
}

- (BOOL)canParsePathExtension:(NSString *)extension;
{
    extension = [extension lowercaseString];
    
    return ([extension isEqualToString:@"jpeg"] ||
            [extension isEqualToString:@"jpg"]  ||
            [extension isEqualToString:@"jpe"]  ||
            [extension isEqualToString:@"png"]  ||
            [extension isEqualToString:@"gif"]  ||
            [extension isEqualToString:@"tiff"] ||
            [extension isEqualToString:@"tif"]  ||
            [extension isEqualToString:@"ico"]  ||
            [extension isEqualToString:@"cur"]  ||
            [extension isEqualToString:@"bmp"]  ||
            [extension isEqualToString:@"bmpf"] ||
            [extension isEqualToString:@"xbm"]);
}

- (id)parsedObjectForData:(NSData *)data withURL:(NSURL *)aURL options:(NSDictionary *)options error:(NSError **)error;
{
    UIImage *ret = [UIImage imageWithData:data];
    
    NSString *lastPathComp = [aURL lastPathComponent];
    
    if([lastPathComp rangeOfString:@"@2x."].location != NSNotFound)
        ret = [UIImage imageWithCGImage:[ret CGImage] scale:2.0 orientation:UIImageOrientationUp];
    
    return ret;
}

@end
