//
//  FAKE_NLHTTPRequestOperation.h
//  NLDataProvider
//
//  Created by Remy Demarest on 15/11/2010.
//  Copyright 2010 NuLayer Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "NLHTTPRequestOperation.h"
#import <NLFoundation/NLFoundation.h>

extern NSString *const NLOperationGETRewriteURL;
extern NSString *const NLOperationGETRewrittenURL;
extern NSString *const NLOperationGETDelegatePrevent;
extern NSString *const NLOperationGETParsedMIMEType;
extern NSString *const NLOperationGETParsedURLExt;
extern NSString *const NLOperationGETParsedSuggest;
extern NSString *const NLOperationGETRawData;
extern NSString *const NLOperationGETError;
extern NSString *const NLOperationGETCancel;

@class FAKE_NSHTTPURLResponse;

@interface FAKE_NLHTTPRequestOperation : NSObject
{
    void (^_requestCompletionBlock)(NSData *resources, NSHTTPURLResponse *response, NSError *error);
    
    FAKE_NSHTTPURLResponse *_responseToReturn;
    NSData                 *_dataToReturn;
    NSError                *_errorToReturn;
    
    NSURL                  *_requestURL;
    NSDictionary           *_requestOptions;
}

+ (id)loadOperationWithURL:(NSURL *)aURL options:(NSDictionary *)options completion:(void (^)(NSData *resources, NSHTTPURLResponse *response, NSError *error))completion;
- (id)initWithURL:(NSURL *)aURL options:(NSDictionary *)options completion:(void (^)(NSData *resources, NSHTTPURLResponse *response, NSError *error))completion;

@property(nonatomic, readonly, copy) NSURL               *requestURL;
@property(nonatomic, readonly, copy) NSDictionary        *requestOptions;

@property(nonatomic) BOOL isCancelled;
@property(nonatomic) BOOL isExecuting;
@property(nonatomic) BOOL isFinished;

@property(nonatomic, readonly) BOOL isReady;
@property(nonatomic, readonly) BOOL isConcurrent;
@property(nonatomic) NSTimeInterval timeoutInterval;
@end

