//
//  FAKE_NSURLConnection.h
//  NLDataProvider
//
//  Created by Remy Demarest on 15/11/2010.
//  Copyright 2010 NuLayer Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

@class FAKE_NSHTTPURLResponse;

extern NSString *const NLOperationGETRequest;
extern NSString *const NLOperationGETError;
extern NSString *const NLOperationGET304;
extern NSString *const NLOperationGET404;
extern NSString *const NLOperationGETCancel;
extern NSString *const NLOperationGETDie;

@interface FAKE_NSURLConnection : NSObject
{
    FAKE_NSHTTPURLResponse *_responseToReturn;
    NSError                *_errorToReturn;
    NSMutableData          *_dataToReturn;
    id                      _delegate;
    BOOL                    _isCancelled;
}
+ (BOOL)canHandleRequest:(NSURLRequest *)request;
+ (NSURLConnection *)connectionWithRequest:(NSURLRequest *)request delegate:(id)delegate;
- (id)initWithRequest:(NSURLRequest *)request delegate:(id)delegate;
- (id)initWithRequest:(NSURLRequest *)request delegate:(id)delegate startImmediately:(BOOL)startImmediately;
- (void)start;
- (void)cancel;
@end
